/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Validity
  Package: spki
  File:    Validity.java
*/

package fi.hut.tcm.spki;
import java.util.Date;
import fi.hut.tcm.spki.*;


/**
  Validity
  
  The validity field in a SPKI certificate.
  
  Can consist of a not-before date, a not-after date and a list of on-line 
  tests. All these are optional.
*/
public interface Validity
  extends Composite, Component {

  /**
  */
  public abstract Date getNotBefore();
  
  
  /**
  */
  public abstract Date getNotAfter();
  
  
  /**
  */
  public abstract OnlineTest getOnlineTest();
  
  
  /**
    Tests if validity is true.
  */
  public abstract boolean test();
  
  
} // Validity

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
