/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Sequence
  Package: format
  File:    Sequence.java
*/

package fi.hut.tcm.spki.format;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.*;
import fi.hut.tcm.spki.impl.Composite;

/**
  Sequence

  A Sequence of certificate data. Consists of an ordered set of keys,
  operations, certificates and signatures, which all implement the SeqEnt-
  interface.
*/
public class Sequence
  extends fi.hut.tcm.spki.impl.Composite
  implements GenericFormat, Format, fi.hut.tcm.spki.Composite, Component {

  /**
  */
  public Sequence() {

  //+ Sequence::Sequence( )
    super();
  //- Sequence::Sequence( )
  }

  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException {

  //+ Sequence::check(Component)
    return (addition instanceof SeqEnt);
  //- Sequence::check(Component)
  }

  /**
  */
  public boolean isSingleCert() {

  //+ Sequence::isSingleCert( )
    return false;
  //- Sequence::isSingleCert( )
  }

  /**
  */
  public void accept(Visitor visitor) {

  //+ Sequence::accept(Visitor)
    visitor.at(this);
  //- Sequence::accept(Visitor)
  }

  /**
  */
  public String toString() {

  //+ Sequence::toString( )
    String result = new String("(sequence");
    for (int i = 0; i < size(); i++)
      result = new String(result + " " + get(i).toString());

    return new String(result + ")");
  //- Sequence::toString( )
  }

} // Sequence

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
