/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Comment
  Package: impl
  File:    Comment.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  Comment
  
  Certificate comment.
*/
public class Comment
  extends ByteString {

  /**
    Creates an empty comment.
  */
  public Comment() {
  
  //+ Comment::Comment( )
    super();
  //- Comment::Comment( )
  }
  
  /**
    Creates a comment with the value as the comment text.
  */
  public Comment(String value) {
  
  //+ Comment::Comment(String)
    super(value);
  //- Comment::Comment(String)
  }
  
  /**
  */
  public String toString() {
  
  //+ Comment::toString( )
    return new String("(comment " + super.toString() + ") ");
  //- Comment::toString( )
  }
  
  /**
  */
  public boolean equals(Object other) {
  
  //+ Comment::equals(Object)
    if ((other instanceof Comment) && 
	(((Comment)other).getValueString().equals(getValueString())) && 
	(((Comment)other).getDisplayHintString().equals(getDisplayHintString())))
      return true;
    else 
      return false;
  //- Comment::equals(Object)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Comment::accept(Visitor)
    visitor.at(this);
  //- Comment::accept(Visitor)
  }
  
} // Comment

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
