/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  ComponentVisitor
  Package: impl
  File:    ComponentVisitor.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.Sequence;

/**
  ComponentVisitor
  
  A common interface for the classes (operations) that are capable of 
  traversing through the GenericFormat composite structure.
*/
public interface ComponentVisitor 
  extends Visitor {

  /**
  */
  public abstract void att(Sequence node);
  
  
  /**
  */
  public abstract void att(SPart node);
  
  
  /**
  */
  public abstract void att(Hash node);
  
  
  /**
  */
  public abstract void att(SExpr node);
  
  
  /**
  */
  public abstract void att(HashAlgName node);
  
  
  /**
  */
  public abstract void att(Issuer node);
  
  
  /**
  */
  public abstract void att(Subject node);
  
  
  /**
  */
  public abstract void att(GeneralOp node);
  
  
  /**
  */
  public abstract void att(HashOp node);
  
  
  /**
  */
  public abstract void att(Name node);
  
  
  /**
  */
  public abstract void att(Keyholder node);
  
  
  /**
  */
  public abstract void att(ThresholdSubj node);
  
  
  /**
  */
  public abstract void att(SecKey node);
  
  
  /**
  */
  public abstract void att(PubKey node);
  
  
  /**
  */
  public abstract void att(PubSigAlgId node);
  
  
  /**
  */
  public abstract void att(SecSigAlgId node);
  
  
  /**
  */
  public abstract void att(OnlineTest node);
  
  
  /**
  */
  public abstract void att(ObjHash node);
  
  
  /**
  */
  public abstract void att(Tag node);
  
  
  /**
  */
  public abstract void att(Sig node);
  
  
  /**
  */
  public abstract void att(Cert node);
  
  
  /**
  */
  public abstract void att(Valid node);
  
  
  /**
  */
  public abstract void att(NotBefore node);
  
  
  /**
  */
  public abstract void att(NotAfter node);
  
  
  /**
  */
  public abstract void att(Deleg node);
  
  
  /**
  */
  public abstract void att(Comment node);
  
  
  /**
  */
  public abstract void att(KVal node);
  
  
  /**
  */
  public abstract void att(Uri node);
  
  
  /**
  */
  public abstract void att(OnlineType node);
  
  
  /**
  */
  public abstract void att(HashValue node);
  
  
  /**
  */
  public abstract void att(Time node);
  
  
  /**
  */
  public abstract void att(HashOfKey node);
  
  
  /**
  */
  public abstract void att(SigVal node);
  
  
  /**
  */
  public abstract void att(ByteString node);
  
  
  /**
  */
  public abstract void att(Lte node);
  
  
  /**
  */
  public abstract void att(Gte node);
  
  
  /**
  */
  public abstract void att(RangeOrdering node);
  
  
  /**
  */
  public abstract void att(TagStar node);
  
  
  /**
  */
  public abstract void att(UpLim node);
  
  
  /**
  */
  public abstract void att(LowLim node);
  
  
  /**
  */
  public abstract void att(TagRange node);
  
  
  /**
  */
  public abstract void att(TagPrefix node);
  
  
  /**
  */
  public abstract void att(TagSet node);
  
  
  /**
  */
  public abstract void att(TagString node);
  
  
  /**
  */
  public abstract void att(TagSimple node);
  
  
  /**
  */
  public abstract void att(TagExpr node);

} // ComponentVisitor

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
