/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  HashValue
  Package: impl
  File:    HashValue.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  HashValue
  
  The value of the hash function.
*/
public class HashValue
  extends ByteString {

  /**
  */
  public HashValue() {
  
  //+ HashValue::HashValue( )
    super();
  //- HashValue::HashValue( )
  }
  
  /**
  */
  public HashValue(byte[] value) {
  
  //+ HashValue::HashValue(byte[])
    super();
    try {
      setValue(value);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- HashValue::HashValue(byte[])
  }
  
  /**
  */
  public HashValue(String value) {
  
  //+ HashValue::HashValue(String)
    super();
    try {
      setValue(value);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- HashValue::HashValue(String)
  }
  
  /**
  */
  public HashValue(byte[] value, byte[] display) {
  
  //+ HashValue::HashValue(byte[], byte[])
    super();
    try {
      setValue(value);
      setDisplayHint(display);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- HashValue::HashValue(byte[], byte[])
  }
  
  /**
  */
  public HashValue(String value, String display) {
  
  //+ HashValue::HashValue(String, String)
    super();
    try {
      setValue(value);
      setDisplayHint(display);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- HashValue::HashValue(String, String)
  }
  
  /**
  */
  public String toString() {
  
  //+ HashValue::toString( )
    return super.toString();
  //- HashValue::toString( )
  }
  
  /**
  */
  public boolean equals(Object other) {
  
  //+ HashValue::equals(Object)
    if ((other instanceof HashValue) && 
	(((HashValue)other).getValueString().equals(getValueString())) && 
	(((HashValue)other).getDisplayHintString().equals(getDisplayHintString())))
      return true;
    else 
      return false;
  //- HashValue::equals(Object)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ HashValue::accept(Visitor)
    visitor.at(this);
  //- HashValue::accept(Visitor)
  }
  
} // HashValue

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
