/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Lte
  Package: impl
  File:    Lte.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  Lte
  
  Defines the ranges "less than or equal" ("le") and "less than" ("l").
*/
public class Lte
  extends ByteString {

  /**
    Creates a Lte object with the default value "le", less than or equal.
  */
  public Lte() {
  
  //+ Lte::Lte( )
    super("le");
  //- Lte::Lte( )
  }
  
  /**
    Creates a Lte object with the String value. Legal values are "le" and "
    l".
  */
  public Lte(String value) {
  
  //+ Lte::Lte(String)
    super();
    try {
      setValue(value);
    } catch (SPKIException e) {
      System.err.println(e); 
    }
  //- Lte::Lte(String)
  }
  
  /**
  */
  public String toString() {
  
  //+ Lte::toString( )
    return new String(" " + getValueString() + " ");
  //- Lte::toString( )
  }
  
  /**
  */
  public boolean equals(Object other) {
  
  //+ Lte::equals(Object)
    if ((other instanceof Lte) && 
	(((Lte)other).getValueString().equals(getValueString())) && 
	(((Lte)other).getDisplayHintString().equals(getDisplayHintString())))
      return true;
    else 
      return false;
  //- Lte::equals(Object)
  }
  
  /**
  */
  public void setValue(byte[] string)
    throws SPKIException  {
  
  //+ Lte::setValue(byte[])
      String test = new String(string);
      if (test.equals("le") || test.equals("l"))
	super.setValue(string);
      else
	throw new SPKIException("Illegal value for lte: " + string);
  //- Lte::setValue(byte[])
  }
  
  /**
  */
  public void setValue(String string)
    throws SPKIException  {
  
  //+ Lte::setValue(String)
      if (string.equals("le") || string.equals("l"))
	super.setValue(string);
      else
	throw new SPKIException("Illegal value for lte: " + string);
  //- Lte::setValue(String)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Lte::accept(Visitor)
    visitor.at(this);
  //- Lte::accept(Visitor)
  }
  
} // Lte

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
