/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  ObjHash
  Package: impl
  File:    ObjHash.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import java.security.MessageDigest;

/**
  ObjHash
  
  Hash of an object.
*/
public class ObjHash
  extends Composite {

  /**
  */
  public ObjHash() {
  
  //+ ObjHash::ObjHash( )
    super();
  //- ObjHash::ObjHash( )
  }
  
  /**
  */
  public ObjHash(Object obj)
    throws IllegalStateException  {
  
  //+ ObjHash::ObjHash(Object)
    super();
    try {
      MessageDigest md = MessageDigest.getInstance("SHA");
      md.update(obj.toString().getBytes());
      Hash h = new Hash();
      HashAlgName algname = new HashAlgName();
      algname.add(new ByteString("sha1"));
      h.add(algname);
      h.add(new HashValue(md.digest()));
      add(h);
    } catch (Exception e) {
      throw new IllegalStateException(); // Not reached.
    }
  //- ObjHash::ObjHash(Object)
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ ObjHash::check(Component)
      if (!(addition instanceof Hash))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- ObjHash::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ ObjHash::accept(Visitor)
      visitor.at(this);
  //- ObjHash::accept(Visitor)
  }
  
} // ObjHash

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
