/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SecSigAlgId
  Package: impl
  File:    SecSigAlgId.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
    SecSigAlgId
    
    The identifier of a Symmetric Key -based signature algorithm. Contains
    either a ByteString or an Uri. The possible string values include:
    "hmac-md5", "hmac-sha1" and "des-cbc-mac".
*/
public class SecSigAlgId
  extends Composite {

  /**
  */
  public SecSigAlgId() {
  
  //+ SecSigAlgId::SecSigAlgId( )
    super();
  //- SecSigAlgId::SecSigAlgId( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ SecSigAlgId::check(Component)
      if (!(addition instanceof Uri) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- SecSigAlgId::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ SecSigAlgId::accept(Visitor)
      visitor.at(this);
  //- SecSigAlgId::accept(Visitor)
  }
  
} // SecSigAlgId

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
