/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SpkiCertFactory
  Package: impl
  File:    SPKICertificateFactory.java
*/

package fi.hut.tcm.spki.impl;
import java.security.cert.CertificateFactorySpi;
import fi.hut.tcm.spki.SPKICertificateFactory;
import fi.hut.tcm.spki.SPKICRL;
import fi.hut.tcm.spki.SPKICertificate;
import fi.hut.tcm.spki.format.*;
import java.util.*;
import java.security.*;
import java.io.InputStream;


/**
  SpkiCertFactory


*/
public class SpkiCertFactory
  extends CertificateFactorySpi implements SPKICertificateFactory {

  /**
  */
  public SpkiCertFactory() {

  //+ SpkiCertFactory::SpkiCertFactory( )
    super();
  //- SpkiCertFactory::SpkiCertFactory( )
  }

  /**
  */
  public java.security.cert.Certificate engineGenerateCertificate(InputStream inStream) {

  //+ SpkiCertFactory::engineGenerateCertificate(InputStream)
      try {
	byte[] buf = new byte[inStream.available()];
	inStream.read(buf);
	CanonicalSpki canonical = new CanonicalSpki();
	canonical.putBuffer(buf);
	CertData tmp = new CertData(canonical);
	tmp.parseCanonicalSpki();

	Sequence seq = (Sequence) tmp.getFormat(new Sequence());
        SpkiCert cert = new SpkiCert();
	cert.putSequence(seq);
	return (java.security.cert.Certificate) cert;
      } catch (Exception e) {
	// FIX: do something that makes sense!
	System.out.println("SpkiCertFactory: Cannot read the certifiate");
	e.printStackTrace();
	return null;
      }
  //- SpkiCertFactory::engineGenerateCertificate(InputStream)
  }

  /**
  */
  public Collection engineGenerateCertificates(InputStream inStream) {

  //+ SpkiCertFactory::engineGenerateCertificates(InputStream)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::engineGenerateCertificates(InputStream)
  }

  /**
  */
  public java.security.cert.CRL engineGenerateCRL(InputStream inStream) {

  //+ SpkiCertFactory::engineGenerateCRL(InputStream)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::engineGenerateCRL(InputStream)
  }

  /**
  */
  public Collection engineGenerateCRLs(InputStream inStream) {

  //+ SpkiCertFactory::engineGenerateCRLs(InputStream)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::engineGenerateCRLs(InputStream)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, fi.hut.tcm.spki.Tag tag) {



  //+ SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag)
    try {

      SpkiCert c = new SpkiCert();
      c.putIssuer(issuer.getPublic());
      c.putSubject(new Subject(subject));
      c.putDeleg(delegation);
      c.putTag(tag);

      c.sign(issuer);


      return c;
    } catch (NoSuchMethodException e) {
      // Never reached...
      System.err.println("Mysterious error in creating a certificate: " + e.toString());
      return null;
    }
  //- SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, Subject subject, boolean delegation, fi.hut.tcm.spki.Tag tag) {

  //+ SpkiCertFactory::makeCert(KeyPair, Subject, boolean, Tag)
    try {
      SpkiCert c = new SpkiCert();
      c.putIssuer(issuer.getPublic());
      c.putSubject(subject);
      c.putDeleg(delegation);
      c.putTag(tag);
      c.sign(issuer);

      return c;
    } catch (NoSuchMethodException e) {
      // Never reached...
      System.err.println("Mysterious error in creating a certificate: " + e.toString());
      return null;
    }
  //- SpkiCertFactory::makeCert(KeyPair, Subject, boolean, Tag)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, byte[] subject, boolean delegation, fi.hut.tcm.spki.Tag tag) {

  //+ SpkiCertFactory::makeCert(KeyPair, byte[], boolean, Tag)
    try {
      SpkiCert c = new SpkiCert();
      c.putIssuer(issuer.getPublic());
      c.putSubject(new Subject(subject));
      c.putDeleg(delegation);
      c.putTag(tag);
      c.sign(issuer);

      return c;
    } catch (NoSuchMethodException e) {
      // Never reached...
      System.err.println("Mysterious error in creating a certificate: " + e.toString());
      return null;
    }
  //- SpkiCertFactory::makeCert(KeyPair, byte[], boolean, Tag)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, fi.hut.tcm.spki.Tag tag, Date notAfter) {

  //+ SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, Date)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, Date)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, fi.hut.tcm.spki.Tag tag, Date notBefore, Date notAfter) {

  //+ SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, Date, Date)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, Date, Date)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, fi.hut.tcm.spki.Tag tag, Date notBefore, Date notAfter, fi.hut.tcm.spki.OnlineTest online) {

  //+ SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, Date, Date, OnlineTest)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, Date, Date, OnlineTest)
  }

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, fi.hut.tcm.spki.Tag tag, fi.hut.tcm.spki.OnlineTest online) {

  //+ SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, OnlineTest)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCert(KeyPair, PublicKey, boolean, Tag, OnlineTest)
  }

  /**
  */
  public SPKICRL makeCrl(Enumeration certificates) {

  //+ SpkiCertFactory::makeCrl(Enumeration)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCrl(Enumeration)
  }

  /**
  */
  public SPKICRL makeCrl(Enumeration certificates, Date notAfter) {

  //+ SpkiCertFactory::makeCrl(Enumeration, Date)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCrl(Enumeration, Date)
  }

  /**
  */
  public SPKICRL makeCrl(Enumeration certificates, Date notBefore, Date notAfter) {

  //+ SpkiCertFactory::makeCrl(Enumeration, Date, Date)
    System.out.println("Debug: not implemented yet");
    return null;
  //- SpkiCertFactory::makeCrl(Enumeration, Date, Date)
  }

} // SpkiCertFactory

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
