/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  TagRange
  Package: impl
  File:    TagRange.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  TagRange
  
  A set of tags containings all tags in a given range.
*/
public class TagRange
  extends Composite {

  /**
  */
  public TagRange() {
  
  //+ TagRange::TagRange( )
    super();
  //- TagRange::TagRange( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ TagRange::check(Component)
      if (!(addition instanceof RangeOrdering) &&
	  !(addition instanceof UpLim) &&
	  !(addition instanceof LowLim))
	return false;
      if ((addition instanceof RangeOrdering) &&
	  (children.size() == 0))
	return true;
      if ((addition instanceof LowLim) &&
	  (children.size() == 1))
	return true;
      if ((addition instanceof UpLim) &&
	  (children.size() > 0) &&
	  (children.size() < 3))
	return true;
      throw new IllegalStateException();
  //- TagRange::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ TagRange::accept(Visitor)
      visitor.at(this);
  //- TagRange::accept(Visitor)
  }
  
} // TagRange

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
