/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  TagString
  Package: impl
  File:    TagString.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  TagString
  
  TagString may be a ByteString, TagRange or TagPrefix.
*/
public class TagString
  extends Composite {

  /**
  */
  public TagString() {
  
  //+ TagString::TagString( )
    super();
  //- TagString::TagString( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ TagString::check(Component)
      if (!(addition instanceof TagRange) &&
	  !(addition instanceof TagPrefix) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- TagString::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ TagString::accept(Visitor)
      visitor.at(this);
  //- TagString::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ TagExpr::toString( )
    String result = new String();
    for (int i = 0; i < size(); i++) {
      result += children.elementAt(i).toString();
      if (i < (size() - 1))
	result += " ";
    }
    return result;
  //- TagExpr::toString( )
  }
  
} // TagString

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
