/* Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 * Modificado por Cristian F. Souza
 */

package javax.net.ssl;

// Imports
import java.lang.Object;
import java.lang.String;
import fi.hut.tcm.spki.SPKICertificate;
import javax.net.ssl.SSLPeerUnverifiedException;
import javax.net.ssl.SSLSessionContext;

public abstract interface SSLSession {

  // Methods
  public String getCipherSuite();
  public long getCreationTime();
  public byte[] getId();
  public long getLastAccessedTime();
  public SPKICertificate[] getPeerCertificateChain() throws SSLPeerUnverifiedException;
  public String getPeerHost();
  public SSLSessionContext getSessionContext();
  public Object getValue(String p0);
  public String[] getValueNames();
  public void invalidate();
  public void putValue(String p0, Object p1);
  public void removeValue(String p0);
}
